diff -uwrN sourceold/scripts/tcw_sp_scripts.cpp source/scripts/tcw_sp_scripts.cpp
--- sourceold/scripts/tcw_sp_scripts.cpp	1970-01-01 08:00:00.000000000 +0800
+++ source/scripts/tcw_sp_scripts.cpp	2012-08-05 10:29:24.414046900 +0800
@@ -0,0 +1,179 @@
+#include "General.h"
+#include "engine.h"
+#include "scripts.h"
+#include "ScriptZoneGameObj.h"
+#include "PhysicalGameObj.h"
+#include "tcw_sp_scripts.h"
+
+void tcw_gdi_sp_harvester::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&state, 4, 1);
+	Auto_Save_Variable(&tiberiumRegion, 60, 2);
+	Auto_Save_Variable(&WaypathID, 4, 3);
+	Auto_Save_Variable(&WaypathBeginID, 4, 4);
+	Auto_Save_Variable(&WaypathEndID, 4, 5);
+	Auto_Save_Variable(&harvestTime, 4, 6);
+	Auto_Save_Variable(&HarvestIdleID, 4, 7);
+	Auto_Save_Variable(&HarvestFullID, 4, 8);
+	Auto_Save_Variable(&HarvestID, 4, 9);
+}
+
+void tcw_gdi_sp_harvester::Created(GameObject *obj)
+{
+	if(!obj || !obj->As_VehicleGameObj())
+	{
+		Destroy_Script();
+		return;
+	}	
+	ScriptZoneGameObj *TiberiumZone = (ScriptZoneGameObj *)Commands->Find_Object(Get_Int_Parameter("TiberiumZone"));
+	if(!TiberiumZone)
+	{
+		Destroy_Script();
+		return;
+	}
+	tiberiumRegion = TiberiumZone->Get_Bounding_Box();
+	state = StateGoingToHarvest;
+	WaypathID = Get_Int_Parameter("WaypathID");
+	WaypathBeginID = Get_Int_Parameter("WaypathBeginID");
+	WaypathEndID = Get_Int_Parameter("WaypathEndID");
+	harvestTime = 15.0f;
+	ActionParamsStruct Params;
+	Params.Set_Basic(this, 100, 1);
+	Params.Set_Movement(0, 1, 1);
+	Params.WaypathID = WaypathID;
+	Params.MovePathfind = true;
+	Commands->Action_Goto(obj, Params);
+	Commands->Enable_Engine(obj, true);
+	Commands->Innate_Disable(obj);
+	GameObject *Tmp1 = Commands->Create_Object_At_Bone(obj, "TCW_GDI_Harv_Idle_FX", "FX");
+	GameObject *Tmp2 = Commands->Create_Object_At_Bone(obj, "TCW_GDI_Harv_Full_FX", "FX");
+	Commands->Attach_To_Object_Bone(Tmp1, obj,"FX");
+	Commands->Attach_To_Object_Bone(Tmp2, obj, "FX");
+	HarvestIdleID = Commands->Get_ID(Tmp1);
+	HarvestFullID = Commands->Get_ID(Tmp2);
+	HarvestID = 0;
+	Commands->Set_Animation(Tmp1, "GDI_HARV_IDLE.GDI_HARV_IDLE",false,0,0,0,false);
+	Commands->Set_Animation(Tmp2, "GDI_HARV_FULL.GDI_HARV_FULL",false,0,1,1,false);
+}
+
+void tcw_gdi_sp_harvester::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
+{
+	if(complete_reason != ACTION_COMPLETE_LOW_PRIORITY)
+	{
+		if(action_id == 1)
+		{
+			state = StateHarvesting;
+			Commands->Enable_Engine(obj, false);
+			obj->As_PhysicalGameObj()->Clear_Animation();
+			Commands->Start_Timer(obj, this, ((((::rand() & 0xFFF) / 4095.0f) * 4.0f) + 3.0f), 2);
+			Commands->Start_Timer(obj, this, harvestTime, 1);
+			Commands->Set_Animation(Commands->Find_Object(HarvestIdleID), "GDI_HARV_IDLE.GDI_HARV_IDLE",false,0,1,1,false);
+			Harvest();
+		}
+		else if(action_id == 2)
+		{
+			ActionParamsStruct Params;
+			Params.Set_Basic(this, 100, 3);
+			Params.Set_Movement(0, 1, 1);
+			Params.WaypathID = WaypathID;
+			Params.WaypointStartID = WaypathBeginID + 1;
+			Params.WaypointEndID = WaypathBeginID;
+			Params.MovePathfind = true;
+			Params.MoveBackup = true;
+			Commands->Action_Goto(obj, Params);
+		}
+		else if(action_id == 3)
+		{
+			state = StateUnloading;	
+			obj->As_PhysicalGameObj()->Clear_Animation();
+			Commands->Enable_Engine(obj, false);
+			Commands->Start_Timer(obj, this, 10, 3);
+		}
+		else if(action_id == 1000)
+		{
+			state = StateHarvesting;
+			Commands->Enable_Engine(obj, false);
+			obj->As_PhysicalGameObj()->Clear_Animation();
+			Commands->Start_Timer(obj, this, ((((::rand() & 0xFFF) / 4095.0f) * 4.0f) + 3.0f), 2);
+			Commands->Set_Animation(Commands->Find_Object(HarvestIdleID), "GDI_HARV_IDLE.GDI_HARV_IDLE",false,0,1,1,false);
+			Harvest();
+		}
+	}
+}
+
+void tcw_gdi_sp_harvester::Timer_Expired(GameObject *obj,int number)
+{
+	if(number == 1)
+	{
+		Stop_Harvest();
+		state = StateGoingToUnload;
+		Commands->Enable_Engine(obj, true);
+		obj->As_PhysicalGameObj()->Clear_Animation();
+		ActionParamsStruct Params;
+		Params.Set_Basic(this, 100, 2);
+		Params.Set_Movement(0, 1, 1);
+		Params.WaypathID = WaypathID;
+		Params.WaypointStartID = WaypathEndID;
+		Params.WaypointEndID = WaypathBeginID + 1;
+		Params.MovePathfind = true;
+		Commands->Action_Goto(obj, Params);
+		Commands->Set_Animation(Commands->Find_Object(HarvestIdleID), "GDI_HARV_IDLE.GDI_HARV_IDLE",false,0,0,0,false);
+		Commands->Set_Animation(Commands->Find_Object(HarvestFullID), "GDI_HARV_FULL.GDI_HARV_FULL",false,0,0,0,false);
+	}
+	else if(number == 2)
+	{
+		if(state == StateHarvesting)
+		{
+			Stop_Harvest();
+			state = StateGoingToHarvest;
+			Commands->Enable_Engine(obj, true);
+			float xrand = WWMath::Random_Float(0.0f,(tiberiumRegion.Extent.X - 5.0f));
+			float yrand = WWMath::Random_Float(0.0f,(tiberiumRegion.Extent.Y - 5.0f));
+			Vector3 loc = (tiberiumRegion.Basis * Vector3(xrand,yrand,0.0f)) + tiberiumRegion.Center;
+			ActionParamsStruct Params;
+			Params.Set_Basic(this, 100, 1000);
+			Params.Set_Movement(loc, 1, 1);
+			Commands->Action_Goto(obj, Params);
+			Commands->Set_Animation(Commands->Find_Object(HarvestIdleID), "GDI_HARV_IDLE.GDI_HARV_IDLE",false,0,0,0,false);
+		}
+	}
+	else if(number == 3)
+	{
+		state = StateGoingToHarvest;
+		ActionParamsStruct Params;
+		Params.Set_Basic(this, 100, 1);
+		Params.Set_Movement(0, 1, 1);
+		Params.WaypathID = WaypathID;
+		Params.MovePathfind = true;
+		Commands->Action_Goto(obj, Params);
+		Commands->Enable_Engine(obj, true);
+		Commands->Set_Animation(Commands->Find_Object(HarvestIdleID), "GDI_HARV_IDLE.GDI_HARV_IDLE",false,0,0,0,false);
+		Commands->Set_Animation(Commands->Find_Object(HarvestFullID), "GDI_HARV_FULL.GDI_HARV_FULL",false,0,1,1,false);
+	}
+}
+
+void tcw_gdi_sp_harvester::Detach(GameObject *obj)
+{
+	ScriptImpClass::Detach(obj);
+	Commands->Destroy_Object(Commands->Find_Object(HarvestIdleID));
+	Commands->Destroy_Object(Commands->Find_Object(HarvestFullID));
+	Commands->Destroy_Object(Commands->Find_Object(HarvestID));
+}
+
+void tcw_gdi_sp_harvester::Harvest()
+{
+	Commands->Destroy_Object(Commands->Find_Object(HarvestID));
+	HarvestID = 0;
+	GameObject *Tmp = Commands->Create_Object_At_Bone(Owner(), "TCW_GDI_Harv_Harving_FX", "FX");
+	Commands->Attach_To_Object_Bone(Tmp, Owner(), "FX");
+	HarvestID = Commands->Get_ID(Tmp);
+	Commands->Set_Animation(Tmp, "GDI_HARVEST.GDI_HARVEST",true,0,0,-1,false);
+}
+
+void tcw_gdi_sp_harvester::Stop_Harvest()
+{
+	Commands->Destroy_Object(Commands->Find_Object(HarvestID));
+	HarvestID = 0;
+}
+
+ScriptRegistrant<tcw_gdi_sp_harvester> tcw_gdi_sp_harvester_Registrant("tcw_gdi_sp_harvester", "TiberiumZone=0:int,WaypathID=0:int,WaypathBeginID=0:int,WaypathEndID=0:int");
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_sp_scripts.h source/scripts/tcw_sp_scripts.h
--- sourceold/scripts/tcw_sp_scripts.h	1970-01-01 08:00:00.000000000 +0800
+++ source/scripts/tcw_sp_scripts.h	2012-08-05 10:29:24.400375000 +0800
@@ -0,0 +1,41 @@
+#pragma once
+
+/*
+	Usage: 
+	Add this script to a GDI harvester.
+	Add a 2 way waypath. The start node MUST be at the refinery and the end node MUST be at the tibfield.
+	The waypath node count must be >= 3
+	Add a zone in the tiberium, that will be the region of roaming in the tiberium.
+	The bigger the zone the further it roams...
+*/
+
+class tcw_gdi_sp_harvester : public ScriptImpClass
+{
+public:
+	enum State
+	{
+		NoState             = 0,
+      	StateGoingToHarvest = 1,
+      	StateHarvesting     = 2,
+      	StateGoingToUnload  = 3,
+      	StateUnloading      = 4,
+	};
+	void Register_Auto_Save_Variables();
+	State Get_State() { return state; }
+protected:
+	void Created(GameObject *obj);
+	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
+	void Timer_Expired(GameObject *obj,int number);
+	void Detach(GameObject *obj);
+	void Harvest();
+	void Stop_Harvest();
+	State state;
+	OBBoxClass tiberiumRegion;
+	int WaypathID;
+	int WaypathBeginID;
+	int WaypathEndID;
+	float harvestTime;
+	int HarvestIdleID;
+	int HarvestFullID;
+	int HarvestID;
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_superweapons.cpp source/scripts/tcw_superweapons.cpp
--- sourceold/scripts/tcw_superweapons.cpp	2012-06-09 08:11:12.347656200 +0800
+++ source/scripts/tcw_superweapons.cpp	2012-07-31 21:54:12.184570300 +0800
@@ -30,26 +30,20 @@
 void tcw_pt_ion::Created(GameObject *obj)
 {
 	Commands->Enable_HUD_Pokable_Indicator(obj, true);
-	someone_has_ion = false;
 	allowpoke = true;
 	ionready = false;
 	Create_2D_WAV_Sound_Team("gdi_ion_cannon_charging.wav",1);
 	Send_Message_Team(1,255,255,255,"Ion Cannon charging");
-	Commands->Start_Timer(obj,this,420.0f,100100);//420=7min
+	Commands->Start_Timer(obj,this,240.0f,100100);//420=7min
 }
 void tcw_pt_ion::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
 	if (message == 1000)
 	{
-		if (param == 1)//person holding the ion died or left game or whatever nub he did
+		if (param == 2)//successful beacon placed, start recharging
 		{
-			someone_has_ion = false;
-		}
-		else if (param == 2)//successful beacon placed, start recharging
-		{
-			someone_has_ion = false;
 			ionready = false;
-			Commands->Start_Timer(obj,this,420.0f,100100);//recharge the ion
+			Commands->Start_Timer(obj,this,240.0f,100100);//recharge the ion
 		}
 	}
 }
@@ -89,7 +83,7 @@
 					allowpoke = false;
 					Commands->Enable_HUD_Pokable_Indicator(obj, false);
 					Commands->Start_Timer(obj,this,5.0f,100101);//alowpoke true
-					if (someone_has_ion)
+					if (Find_Object_With_Script("tcw_i_have_ion_beacon"))//someone has ion already
 					{
 						char currholdermsg[250];
 						sprintf(currholdermsg,"Sorry, %s currently has the Ion Cannon Beacon.",Get_Player_Name(Find_Object_With_Script("tcw_i_have_ion_beacon")));
@@ -99,7 +93,6 @@
 					{
 						if (ionready)
 						{
-							someone_has_ion = true;
 							Attach_Script_Once(poker,"tcw_i_have_ion_beacon","");
 							Commands->Give_PowerUp(poker,"TCW_POW_Beacon_IonCannon_60Sec",false);
 							char pickupmsg[250];
@@ -122,9 +115,8 @@
 }
 void tcw_pt_ion::Register_Auto_Save_Variables()
 {
-	Auto_Save_Variable(&someone_has_ion,sizeof(someone_has_ion),1);
-	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),2);
-	Auto_Save_Variable(&ionready,sizeof(ionready),3);
+	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),1);
+	Auto_Save_Variable(&ionready,sizeof(ionready),2);
 }
 
 void tcw_gdi_ion_cannon_building::Custom(GameObject *obj, int message, int param, GameObject *sender)
@@ -157,32 +149,26 @@
 //NUKE SCRIPTS HERE
 void tcw_i_have_nuke_beacon::Destroyed(GameObject *obj)
 {
-	Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_pt_nuke"),1000,1,0);//someone has ion is false
+	Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_pt_nuke"),1000,1,0);//someone has nuke is false
 }
 
 void tcw_pt_nuke::Created(GameObject *obj)
 {
 	Commands->Enable_HUD_Pokable_Indicator(obj, true);
-	someone_has_ion = false;
 	allowpoke = true;
 	ionready = false;
 	Create_2D_WAV_Sound_Team("nod_nuke_charging.wav",0);
 	Send_Message_Team(0,255,255,255,"Nuclear Missile charging");
-	Commands->Start_Timer(obj,this,420.0f,100100);
+	Commands->Start_Timer(obj,this,240.0f,100100);
 }
 void tcw_pt_nuke::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
 	if (message == 1000)
 	{
-		if (param == 1)//person holding the ion died or left game or whatever nub he did
-		{
-			someone_has_ion = false;
-		}
-		else if (param == 2)//successful beacon placed, start recharging
+		if (param == 2)//successful beacon placed, start recharging
 		{
-			someone_has_ion = false;
 			ionready = false;
-			Commands->Start_Timer(obj,this,420.0f,100100);//recharge the ion
+			Commands->Start_Timer(obj,this,240.0f,100100);//recharge the nuke
 		}
 	}
 }
@@ -213,7 +199,7 @@
 			}
 			else 
 			{
-				if (Is_Building_Dead(Find_Building_By_Preset(1,"TCW_Temple_of_Nod")))
+				if (Is_Building_Dead(Find_Building_By_Preset(0,"TCW_Temple_of_Nod")))
 				{
 					Send_Message_Player(poker,255,255,255,"Your Temple of Nod is destroyed. The Nuclear Missile is unavailable.");
 				}
@@ -222,7 +208,7 @@
 					allowpoke = false;
 					Commands->Enable_HUD_Pokable_Indicator(obj, false);
 					Commands->Start_Timer(obj,this,5.0f,100101);//alowpoke true
-					if (someone_has_ion)
+					if (Find_Object_With_Script("tcw_i_have_nuke_beacon"))
 					{
 						char currholdermsg[250];
 						sprintf(currholdermsg,"Sorry, %s currently has the Nuclear Missile Beacon.",Get_Player_Name(Find_Object_With_Script("tcw_i_have_nuke_beacon")));
@@ -232,7 +218,6 @@
 					{
 						if (ionready)
 						{
-							someone_has_ion = true;
 							Attach_Script_Once(poker,"tcw_i_have_nuke_beacon","");
 							Commands->Give_PowerUp(poker,"TCW_POW_Beacon_Nuke_60Sec",false);
 							char pickupmsg[250];
@@ -255,9 +240,8 @@
 }
 void tcw_pt_nuke::Register_Auto_Save_Variables()
 {
-	Auto_Save_Variable(&someone_has_ion,sizeof(someone_has_ion),1);
-	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),2);
-	Auto_Save_Variable(&ionready,sizeof(ionready),3);
+	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),1);
+	Auto_Save_Variable(&ionready,sizeof(ionready),2);
 }
 
 void tcw_nod_nuke_building::Created(GameObject *obj)
diff -uwrN sourceold/scripts/tcw_superweapons.h source/scripts/tcw_superweapons.h
--- sourceold/scripts/tcw_superweapons.h	2012-06-09 08:11:12.188476500 +0800
+++ source/scripts/tcw_superweapons.h	2012-07-31 21:54:12.031250000 +0800
@@ -26,7 +26,6 @@
 public: void Register_Auto_Save_Variables();
 bool ionready;
 bool allowpoke;
-bool someone_has_ion;
 };
 
 class tcw_gdi_ion_cannon_building : public ScriptImpClass {
@@ -47,7 +46,6 @@
 public: void Register_Auto_Save_Variables();
 bool ionready;
 bool allowpoke;
-bool someone_has_ion;
 };
 
 class tcw_nod_nuke_building : public ScriptImpClass {
diff -uwrN sourceold/scripts/tcw_technology.cpp source/scripts/tcw_technology.cpp
--- sourceold/scripts/tcw_technology.cpp	2012-06-09 08:11:12.150390600 +0800
+++ source/scripts/tcw_technology.cpp	2012-07-31 21:54:12.194335900 +0800
@@ -52,7 +52,7 @@
 									researching_composit_armor_upgrade = true;
 									Commands->Start_Timer(obj,this,20.0f,10001);
 									Create_2D_WAV_Sound_Team("gdi_tech_upgrade_in_progress.wav",1);
-									Send_Message_Team(1,255,204,0,"Upgrade in progress: Composite Armor.");
+									Send_Message_Team(1,5,220,220,"Upgrade in progress: Composite Armor.");
 									allowpokegdi = false;
 								}
 							}
@@ -92,7 +92,7 @@
 			Vector3 pos; pos.Z = 999.0f; pos.Y = 999.0f; pos.X = 999.0f;
 			GameObject *compositarmor = Commands->Create_Object("TCW_Tech_Composit_Armor_Available",pos);
 			Commands->Set_Facing(compositarmor,0.0f);
-			Send_Message_Team(1,255,204,0,"Upgrade Complete: Composite Armor.");
+			Send_Message_Team(1,5,220,220,"Upgrade Complete: Composite Armor.");
 			Create_2D_WAV_Sound_Team("gdi_tech_upgrade_complete.wav",1);
 			researched_composit_armor_upgrade = true;
 			researching_composit_armor_upgrade = false;
@@ -295,7 +295,7 @@
 	{
 		Commands->Start_Timer(obj,this,15.0f,779902);//start stealing from the gdi wf
 		char stealermsg[250];
-		sprintf(stealermsg,"%s is stealing technology from the Nod Weapons Factory.",Get_Player_Name(obj));
+		sprintf(stealermsg,"%s is stealing technology from the Nod War Factory.",Get_Player_Name(obj));
 		Send_Message_Team(1,255,204,0,stealermsg);
 		Create_2D_WAV_Sound_Team("building_capture.wav",1);
 	}
@@ -363,7 +363,7 @@
 				Hide_Preset_By_Name(1,"TCW_GDI_Stealth_Tank",false);
 
 				char stealmsg[250];
-				sprintf(stealmsg,"%s has stolen technology from the Nod Weapons Factory",Get_Player_Name(obj));
+				sprintf(stealmsg,"%s has stolen technology from the Nod War Factory",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,stealmsg);
 				Send_Message_Team(1,255,204,0,"New technology acquired.");
 				Create_2D_WAV_Sound_Team("gdi_new_tech_acquired.wav",1);
@@ -472,7 +472,7 @@
 									researching_powerpacks_upgrade = true;
 									Commands->Start_Timer(obj,this,60.0f,10001);
 									Create_2D_WAV_Sound_Team("gdi_tech_upgrade_in_progress.wav",1);
-									Send_Message_Team(1,255,204,0,"Upgrade in progress: Power Packs.");
+									Send_Message_Team(1,5,220,220,"Upgrade in progress: Power Packs.");
 									allowpokegdi = false;
 								}
 							}
@@ -512,7 +512,7 @@
 			Vector3 pos; pos.Z = 999.0f; pos.Y = 999.0f; pos.X = 999.0f;
 			GameObject *powerpacks = Commands->Create_Object("TCW_Tech_Power_Packs_Available",pos);
 			Commands->Set_Facing(powerpacks,0.0f);
-			Send_Message_Team(1,255,204,0,"Upgrade Complete: Power Packs.");
+			Send_Message_Team(1,5,220,220,"Upgrade Complete: Power Packs.");
 			Create_2D_WAV_Sound_Team("gdi_tech_upgrade_complete.wav",1);
 			researched_powerpacks_upgrade = true;
 			researching_powerpacks_upgrade = false;
diff -uwrN sourceold/scripts/tcw_tiberium.cpp source/scripts/tcw_tiberium.cpp
--- sourceold/scripts/tcw_tiberium.cpp	2012-06-09 08:11:12.176757800 +0800
+++ source/scripts/tcw_tiberium.cpp	2012-08-05 10:29:24.407210900 +0800
@@ -22,10 +22,10 @@
 #include "tcw_TCWSoldierObj.h"
 
 /////////////////////////////////////////////////////////
-//					TCW_TIBERIUM_HARVESTER
+//					TCW_TIBERIUM_HARVESTER (PLAYER)
 ////////////////////////////////////////////////////////
 
-float TCW_Tiberium_Harvester::Get_Cash()
+float tcw_tiberium_harvester::Get_Cash()
 {
 	float Return = 0;
 	for(int x = 0; x < 8; x++)
@@ -33,14 +33,14 @@
 	return Return;
 }
  
-void TCW_Tiberium_Harvester::Clear_Cash()
+void tcw_tiberium_harvester::Clear_Cash()
 {
 	for(int x = 0; x < 8; x++)
 		CashCollected[x] = 0;
 	CashIndex = 0;
 }
 
-void TCW_Tiberium_Harvester::Created(GameObject *obj)
+void tcw_tiberium_harvester::Created(GameObject *obj)
 {
 
 	if (Is_TCW_Harvester(obj)) // When we are a harvester..
@@ -62,7 +62,7 @@
 		Destroy_Script(); // No need to leave the mess...
 }
 
-void TCW_Tiberium_Harvester::Custom(GameObject *obj, int message, int param, GameObject *sender)
+void tcw_tiberium_harvester::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
 	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
 	{
@@ -178,7 +178,7 @@
 	}
 }
 
-void TCW_Tiberium_Harvester::Timer_Expired(GameObject *obj, int number)
+void tcw_tiberium_harvester::Timer_Expired(GameObject *obj, int number)
 {
 	if(number == CUSTOM_EVENT_TIB_ENTERED && Harvesting && CashIndex < 8) // When in a tib field timer started, harvesting and we're not full do...
 	{	// Check what we need to distribute
@@ -208,12 +208,12 @@
 //					TCW_TIBERIUM_FIELD
 ////////////////////////////////////////////////////////
 
-void TCW_Tiberium_Field::Created(GameObject *obj)
+void tcw_tiberium_field::Created(GameObject *obj)
 {
 	Zonetype = Get_Int_Parameter("Zonetype"); //0=green 1=blue
 }
 
-void TCW_Tiberium_Field::Entered(GameObject *obj, GameObject *enterer)
+void tcw_tiberium_field::Entered(GameObject *obj, GameObject *enterer)
 {
 	if (Is_TCW_Harvester(enterer))
 	{
@@ -224,7 +224,7 @@
 	}
 }
 
-void TCW_Tiberium_Field::Exited(GameObject *obj, GameObject *exiter)
+void tcw_tiberium_field::Exited(GameObject *obj, GameObject *exiter)
 {
 	if ( Is_TCW_Harvester(exiter))
 		Commands->Send_Custom_Event(obj, exiter, CUSTOM_EVENT_HARVY_LEFT_TIBFIELD, 0, 0);//tell harv left zone
@@ -234,17 +234,23 @@
 //					TCW_TIBERIUM_DEPOSIT
 ////////////////////////////////////////////////////////
 
-void TCW_Tiberium_Deposit::Entered(GameObject *obj, GameObject *enterer)
+void tcw_tiberium_deposit::Entered(GameObject *obj, GameObject *enterer)
 {
 	if(Is_TCW_Harvester(enterer))
 		Commands->Send_Custom_Event(obj,enterer, CUSTOM_EVENT_HARVY_DEPOSITING, 0, 0);
+	
+	if (strcmp(Commands->Get_Preset_Name(enterer),"TCW_GDI_Harvester") == 0)
+	{
+		Commands->Send_Custom_Event(obj, enterer, 12500, 0, 0);//tell harv set idle on
+		Commands->Send_Custom_Event(obj, enterer, 12505, 0, 0);//tell harv set full off
+	}
 }
 
 /////////////////////////////////////////////////////////
 //					TCW_TIBERIUM_SPIKE
 ////////////////////////////////////////////////////////
 
-void TCW_Tiberium_Spike::Created(GameObject *obj)
+void tcw_tiberium_spike::Created(GameObject *obj)
 {
 	FirstCapture = true;
 	int SpikeTeam = Commands->Get_Player_Type(obj);
@@ -253,6 +259,7 @@
 		Commands->Set_Animation(obj, "V_NEU_SPIKE.V_NEU_SPIKE", true, 0, 0, 0, 0);
 		Set_Skin(obj, "Blamo");
 		Commands->Set_Health(obj, 1);
+		alive = false;
 	}
 	else if(SpikeTeam == 0 || SpikeTeam == 1)
 	{
@@ -260,10 +267,11 @@
 		Commands->Set_Health(obj, Commands->Get_Max_Health(obj));
 		Set_Skin(obj, "CNCMCTSkin");
 		Commands->Start_Timer(obj, this, 1, 1);
+		alive = true;
 	}
 }
 
-void TCW_Tiberium_Spike::Custom(GameObject *obj, int message, int param, GameObject *sender)
+void tcw_tiberium_spike::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
 	if (message == CUSTOM_EVENT_CAPTURE_SPIKE)
 	{
@@ -278,6 +286,7 @@
 				Commands->Give_Money(sender, 250, true);
 		}
 		Commands->Start_Timer(obj, this, 1, 1);
+		alive = true;
 	}
 	else if(message == CUSTOM_EVENT_CAPTURE_SPIKE_START_NOD)
 	{
@@ -287,6 +296,7 @@
 		Commands->Set_Animation(obj, "V_NEU_SPIKE.V_NEU_SPIKE", true, 0, 1, -1, 0);
 		Commands->Set_Health(obj, Commands->Get_Max_Health(obj));
 		Set_Skin(obj, "CNCMCTSkin");
+		alive = true;
 	}
 	else if(message == CUSTOM_EVENT_CAPTURE_SPIKE_START_GDI)
 	{
@@ -296,10 +306,11 @@
 		Commands->Set_Animation(obj, "V_NEU_SPIKE.V_NEU_SPIKE", true, 0, 1, -1, 0);
 		Commands->Set_Health(obj, Commands->Get_Max_Health(obj));
 		Set_Skin(obj, "CNCMCTSkin");
+		alive = true;
 	}
 }
 
-void TCW_Tiberium_Spike::Timer_Expired(GameObject *obj, int number)
+void tcw_tiberium_spike::Timer_Expired(GameObject *obj, int number)
 {
 	if(number == 1 && (Commands->Get_Player_Type(obj) == 0 || Commands->Get_Player_Type(obj) == 1))
 	{
@@ -308,14 +319,32 @@
 	}
 }
 
-void TCW_Tiberium_Spike::Damaged(GameObject *obj, GameObject *damager, float damage)
+void tcw_tiberium_spike::Damaged(GameObject *obj, GameObject *damager, float damage)
 {
 	if(damage > Commands->Get_Health(obj) && (Commands->Get_Player_Type(obj) == 0 || Commands->Get_Player_Type(obj) == 1))
 	{
 		Set_Skin(obj, "Blamo");
 		Commands->Set_Health(obj, 1);
-		Commands->Set_Player_Type(obj, -2);
 		Commands->Set_Animation(obj, "V_NEU_SPIKE.V_NEU_SPIKE", true, 0, 0, 0, 0);
+		if (alive)
+		{
+			if (Commands->Get_Player_Type(obj) == 0)
+			{
+				Create_2D_WAV_Sound_Team("nod_spike_destroyed.wav",1);
+				Create_2D_WAV_Sound_Team("nod_spike_lost.wav",0);
+				Send_Message_Team(0,255,255,255,"Nod Tiberium Spike lost.");
+				Send_Message_Team(1,255,255,255,"Nod Tiberium Spike destroyed.");
+			}
+			else if (Commands->Get_Player_Type(obj) == 1)
+			{
+				Create_2D_WAV_Sound_Team("gdi_spike_lost.wav",1);
+				Create_2D_WAV_Sound_Team("gdi_spike_destroyed.wav",0);
+				Send_Message_Team(0,255,255,255,"GDI Tiberium Spike destroyed.");
+				Send_Message_Team(1,255,255,255,"GDI Tiberium Spike lost.");
+			}
+			alive = false;
+		}
+		Commands->Set_Player_Type(obj, -2);
 	}
 	if(damage < 0 && Commands->Get_Player_Type(obj) == -2)
 		Commands->Set_Health(obj, 1);
@@ -325,7 +354,7 @@
 //				TCW_TIBERIUM_SPIKE_CAPTURE_ZONE
 ////////////////////////////////////////////////////////
 
-void TCW_Tiberium_Spike_Capture_Zone::Created(GameObject *obj)
+void tcw_tiberium_spike_capture::Created(GameObject *obj)
 {
 	Capturer = 0;
 	SpikeID = Get_Int_Parameter("SpikeID");
@@ -333,7 +362,7 @@
 		Destroy_Script();
 }
 
-void TCW_Tiberium_Spike_Capture_Zone::Entered(GameObject *obj, GameObject *enterer)
+void tcw_tiberium_spike_capture::Entered(GameObject *obj, GameObject *enterer)
 {
 	if(Commands->Is_A_Star(enterer) && !Get_Vehicle(enterer) && !Capturer)
 	{
@@ -354,7 +383,7 @@
 				else
 				{
 					Capturer = enterer->Get_ID();
-					Commands->Start_Timer(obj, this, 20, 1);
+					Commands->Start_Timer(obj, this, 15, 1);
 					if(Commands->Get_Player_Type(enterer) == 0)
 					{
 						Send_Message_Team(0, 255, 0, 0, PackArg("%s is capturing a Tiberium Spike.", Get_Player_Name(enterer)));
@@ -369,15 +398,14 @@
 			}
 		}
 	}
-		
 }
 
-void TCW_Tiberium_Spike_Capture_Zone::Exited(GameObject *obj, GameObject *exiter)
+void tcw_tiberium_spike_capture::Exited(GameObject *obj, GameObject *exiter)
 {
 	if (Commands->Is_A_Star(exiter) && exiter->Get_ID() == Capturer)
 			Capturer = 0;
 }
-void TCW_Tiberium_Spike_Capture_Zone::Timer_Expired(GameObject *obj, int number)
+void tcw_tiberium_spike_capture::Timer_Expired(GameObject *obj, int number)
 {
 	if(number == 1)
 	{
@@ -427,7 +455,7 @@
 	}
 }
 
-void tcw_Set_Spike_Team_Created::Created(GameObject *obj)
+void tcw_set_spike_team_created::Created(GameObject *obj)
 {
 	int team = Get_Int_Parameter("Team");
 	if (team == 0)
@@ -445,13 +473,11 @@
 }
 
 
-ScriptRegistrant<tcw_Set_Spike_Team_Created> tcw_Set_Spike_Team_Created_Registrant("tcw_Set_Spike_Team_Created","Team=0:int");
-
-ScriptRegistrant<TCW_Tiberium_Spike> tcw_tiberium_spike_Registrant("tcw_tiberium_spike","");
-ScriptRegistrant<TCW_Tiberium_Spike_Capture_Zone> tcw_tiberium_spike_capture_Registrant("tcw_tiberium_spike_capture","SpikeID=0:int");
-
+ScriptRegistrant<tcw_set_spike_team_created> tcw_set_spike_team_created_Registrant("tcw_set_spike_team_created","Team=0:int");
 
+ScriptRegistrant<tcw_tiberium_spike> tcw_tiberium_spike_Registrant("tcw_tiberium_spike","");
+ScriptRegistrant<tcw_tiberium_spike_capture> tcw_tiberium_spike_capture_Registrant("tcw_tiberium_spike_capture","SpikeID=0:int");
 
-ScriptRegistrant<TCW_Tiberium_Harvester> tcw_Tiberium_Harvester_New_Registrant("tcw_Tiberium_Harvester_New","");
-ScriptRegistrant<TCW_Tiberium_Field> tcw_Tiberium_Field_New_Registrant("tcw_Tiberium_Field_New","Zonetype=0:int");
-ScriptRegistrant<TCW_Tiberium_Deposit> tcw_Tiberium_Deposit_New_Registrant("tcw_Tiberium_Deposit_New","");
+ScriptRegistrant<tcw_tiberium_harvester> tcw_tiberium_harvester_Registrant("tcw_tiberium_harvester","");
+ScriptRegistrant<tcw_tiberium_field> tcw_tiberium_field_Registrant("tcw_tiberium_field","Zonetype=0:int");
+ScriptRegistrant<tcw_tiberium_deposit> tcw_tiberium_deposit_Registrant("tcw_tiberium_deposit","");
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_tiberium.h source/scripts/tcw_tiberium.h
--- sourceold/scripts/tcw_tiberium.h	2012-06-09 08:11:12.321289000 +0800
+++ source/scripts/tcw_tiberium.h	2012-08-05 10:29:24.402328100 +0800
@@ -14,7 +14,7 @@
 
 #pragma once
 
-class TCW_Tiberium_Harvester : public ScriptImpClass 
+class tcw_tiberium_harvester : public ScriptImpClass 
 {
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
@@ -31,7 +31,7 @@
 	int CashIndex;
 };
 
-class TCW_Tiberium_Field : public ScriptImpClass 
+class tcw_tiberium_field : public ScriptImpClass 
 {
 	void Created(GameObject *obj);
 	void Entered(GameObject *obj, GameObject *enterer);
@@ -39,21 +39,22 @@
 	int Zonetype;
 };
 
-class TCW_Tiberium_Deposit : public ScriptImpClass 
+class tcw_tiberium_deposit : public ScriptImpClass 
 {
 	void Entered(GameObject *obj, GameObject *enterer);
 };
 
-class TCW_Tiberium_Spike : public ScriptImpClass
+class tcw_tiberium_spike : public ScriptImpClass
 {
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
 	void Damaged(GameObject *obj, GameObject *damager, float damage);
 	void Timer_Expired(GameObject *obj, int number);
 	bool FirstCapture;
+	bool alive;
 };
 
-class TCW_Tiberium_Spike_Capture_Zone : public ScriptImpClass
+class tcw_tiberium_spike_capture : public ScriptImpClass
 {
 	void Created(GameObject *obj);
 	void Entered(GameObject *obj, GameObject *enterer);
@@ -63,7 +64,7 @@
 	int SpikeID;
 };
 
-class tcw_Set_Spike_Team_Created : public ScriptImpClass {
+class tcw_set_spike_team_created : public ScriptImpClass {
 	void Created(GameObject *obj);
 };
 
